% a simple demonstration on the usage of Stacked PSD on GBM samples

clear all; close all; clc

addpath(genpath('./spams-matlab/'))
addpath minFunc/

datasetname = 'Data/GBM/';
subtypename{1} = '/Necrosis/';
subtypename{2} = '/NecrosisTransition/';
subtypename{3} = '/Tumor/';

foldernames{1} = [datasetname subtypename{1}];
foldernames{2} = [datasetname subtypename{2}];
foldernames{3} = [datasetname subtypename{3}];
    
imageformat{1} = 'bmp';
imageformat{2} = 'tif';
winsize = 20;
colorimage = true;
npatches = 25;

downsample = 1;
numlayers = 2;
nbasis_vec = [256 128];
lambda_vec = [30 30];
nepoch_vec = [10 10];
optmethod = 1; %<---- minfun = 1
whitenning = 0;
initialization = 0;

outputfolder = 'Results/'
outputfile = [outputfolder 'GBM_Stacked_PSD' '_nbasis=' mat2str(nbasis_vec) '_lambda=' mat2str(lambda_vec) '_ite=' mat2str(nepoch_vec) '_numlayers_'];

tstr = Image_Feature_learning_StackPSD_server(foldernames,imageformat,winsize,colorimage,npatches,outputfile,downsample,numlayers,nbasis_vec,lambda_vec,nepoch_vec,optmethod,whitenning,initialization)